<template>
  <div>
    <section  class="sect-header">
        <div  class="item-data" >
            <h1>consultas <span class="color-prime">respondidas</span></h1>
            <hr class="head-hr">
            <p class="slogan">
                {{ username }} has respondido {{listMessages.length}} consultas
            </p>
        </div>

        <div class="item">
            <ul>
                <li v-for="(listmessage, index) in filteredItems" 
                    :key="index"  
                    class="cursor-pointer ">

                    <div class="initial-title-message">
                        <div>
                            {{index + 1}}
                            <span class="stick">|</span> 
                            <i>Re: {{listmessage.subject.substr(0, numMaxSubstr)}}</i>
                        </div>
                        <div class="initial-reply-message">
                            <div class="reply-substring">
                                <strong>
                                    {{listmessage.reply.substr(0, numMaxSubstr)}}
                                </strong>
                            </div>
                            <div class="other-data">  
                                    <div v-if="listmessage.star">
                                        <span class="stick">|</span>
                                        <strong>Valoración: {{listmessage.star}}</strong>
                                    </div>
                                    <span class="stick">|</span> 

                                    {{getHumanDate (listmessage.date)}}

                                    <button v-on:click="show = index" v-if="index !== show" class="butt-show">
                                        <i class="icon-eye ico-align"></i>
                                    </button>
                                    <button v-on:click="show = -1" v-if="index === show" class="butt-show color-hide">
                                        <i class="icon-eye-off"></i>
                                    </button>
                            </div>
                        </div>

                    </div>
                    <!-- mensaje interior -->
                    <div class="reply-doctor" v-if="listmessage.reply" >
                        
                        <div v-if="index === show">
                            <hr>
                            <h3>
                                consulta:
                            </h3>
                            <p class="padding-bot05">
                                Para:{{listmessage.to_message}} / {{listmessage.specialty_group}}
                            </p>
                            <p class="padding-bot05 ">
                                {{listmessage.subject}} | {{getHumanDate (listmessage.date_send_message)}}
                            </p>
                            <p>
                                {{listmessage.message}} 
                            </p>
                            <hr class="head-hr">
                            <h3>
                                respuesta
                            </h3>
                            <p class="padding-bot05 ">
                                Para:{{listmessage.from_message}}
                            </p>
                            <p>
                                {{listmessage.reply}}
                            </p>
                        </div>
                    </div>

                </li> 

                <button  @click="chargeAll += 2" v-if="listMessages.length > chargeAll" class="button-prime spacer-bott">Ver más de {{listMessages.length}} mails</button>

            </ul>
        </div>

        
    </section>
  </div>
</template>

<script>
import moment from 'moment'
import { getName } from '../../../backend/utils/utils' // traemos el nombre de usuario para el menu

export default {
    name: 'MessagesSentEmailCustom',
    data(){
        return{
        // ocultar respuesta
        show: -1,
            
        // BOT CARGAR MAS, iniciar el numero de resultados iniciales 
        chargeAll: 5,

        // En el subject mostrar sólo parte el mensaje...
        numMaxSubstr: "50",
        numMaxSubstrMessage: "100",
        total: 0,

        username: '',


        }
    },
   computed: {
    // función para cargar más mensajes
    filteredItems() {
        return this.listMessages.slice(0, this.chargeAll)
        }
    },

    props: {
        // recibimos lista mensajes
        listMessages: Array,
        

    },
   

    methods:{
        // traer el nombre
        setUserName(){
            this.username = getName()
        },
        // pasar indice
        enviarIndice(index){
            let dataMessage = this.listMessages[index] // datos del mensaje pulsado

            this.$emit('MessageIdEmit', dataMessage) // recogemos evento con $emit
        },

        // modificar fecha con moment
        getHumanDate : function (date) {
                return moment(date, 'YYYY-MM-DD').format('DD/MM/YYYY');
            }
    },

  created(){
    this.setUserName()
  }

}
</script>

<style scoped>


.sect-header {
    display: flex;
    flex-direction: column;
    margin-bottom: 2rem;
}

.item {
    flex: 1;
}

.item-data {
    flex: 0.5;
    margin-bottom: 2rem;
}

li {
    list-style: none;
    text-align: left;
    border-radius: 4px;
    padding:var(--spacer-15) 1rem;
    margin:0.4rem;
    border: 1px solid var( --color-general-whitesmoke);
    border-left: 5px solid var(--color-general-salmon);
    box-shadow: 0px 3px 8px -2px rgba(0,0,0,0.1);
    

    }

li:hover {
    /* background: var( --color-general-whitesmoke); */
    color:var(--color-general-salmon);
    animation-name: messages-list;
    animation-duration: 0.5s;
    animation-fill-mode: forwards;

    }


.head-hr {
    margin-top: 1rem;
}

.initial-title-message{
    display: flex;
    flex-direction: column;
}
.initial-reply-message{
    display: flex;
    flex-direction: row;
}

.spacer-bott{
 margin-top: var(--spacer-15);
}

.stick {
    color:var(--color-general-lightgrey);
    padding: 0 var(--spacer-05);
}


.butt-show{
    background-color:transparent;
    border: 0;
    padding-left:var(--spacer-2);
    font-size: 1rem;
}
.color-hide{
        color:var(--color-general-salmon);
}

.other-data {
    display: flex;
    margin-left: auto;
    font-size: var(--font-size-075);
    color:var(--color-general-graymedium);
}

.reply-substring {
    padding-left: var(--spacer-2)
}

.reply-doctor{
    flex: 1;
    flex-direction:column;
    margin-top: var(--spacer-15);
    padding-left: var(--spacer-15);
    color:var(--color-general-black);;

}


</style>